divert(-1)
#********************************************************************
#  File PROTOKEN.M4
#  M4 definitions for implementing the Retargetable Concurrent Small C
#  virtual machine on the Parallax Propeller
#
#  Remember: c file name must be DOS 8.3 format !!!
#
#  compile c program: rcsc2 program.c
#  this will create program.m4
#  compile m4 to spin: m4 protoken.m4 program.m4 > program.spin
#
#December 27, 2007 Peter Verkaik
#
#********************************************************************
#
#RCSC pseudo instructions
#
#********************************************************************
define(`CSCEXTRN',`{{Retargetable Concurrent Small C compiler}}
')

define(`CSCTERM',
`OBJ
  rcsc: "rcsc"

PUB main
  rcsc.reset(@_main)
  rcsc.run(0)
')

define(`EXTERNAL',
`{{`include' $1()}}')

define(`TOSEG',
`define(`CURSEG', $1) ifelse($1, 1, `',`')')

define(`ENDSEG',
`ifelse($1, 1,`',`')')

define(`DECLPUBLIC',
`ifelse(CURSEG, 2, `
$1', `
DECLARE($1)')')

define(`DECLARE', 
`define(`LABELON', 1)
DECLAREMEM($1,')dnl

define(`REFm', 
`define(`LABELON', 1)
REFmMEM($1,')dnl

define(`SHADOW', `')
define(`MODULENAME', `')
define(`BEGINLIT', `')
define(`ENDLIT', `')
define(`BEGINDUMP', `')dnl

#********************************************************************
#
#macros used internally
#
#********************************************************************
define(`repeat', 
`ifelse(eval($2 <= 0), 1, , 
`repeat(`$1', decr($2))'
$1)')

define(`DECLAREMEM', 
`define(`LABELON', 0)
ifelse($2, _WORD_, `$1		word	', 
$2, _WORDn, `$1		word	$3',
$2, _WORDr0, `$1		word	0[$3]',
$2, _BYTE_, `$1		byte	', 
$2, _BYTEn, `$1		byte	$3',
`$1		byte	0[$3]')')

define(`REFmMEM', 
`define(`LABELON', 0)
ifelse($2, _WORD_, `$1		word	', 
$2, _WORDn, `$1		word	$3',
$2, _WORDr0, `$1		word	0[$3]',
$2, _BYTE_, `$1		byte	', 
$2, _BYTEn, `$1		byte	$3',
`$1		byte	0[$3]')')

#********************************************************************
#
#interrupt, task and monitor table creation macros
#
#********************************************************************
define(`INTRS', 
`	byte	$1,$2')

define(`TASKS', 
`	byte	$1,$2,$3')

define(`MNTRS',
`	byte	$1')

#********************************************************************
#
#RCSC virtual machine instruction set
#
#********************************************************************
#
# Generates tokenized output.
# PCODE constant is followed by max. 3 operands.
# The last operand may be a 12bits word. (Others are 8bit).

define(`ADD12',
`	byte	rcsc#pADD12')

define(`ADD1n',
`	byte	rcsc#pADD1n,($1)&255,($1)>>8')

define(`ADD21',
`	byte	rcsc#pADD21')

define(`ADD2n',
`	byte	rcsc#pADD2n,($1)&255,($1)>>8')

define(`ADDbpn',
`	byte	rcsc#pADDbpn,($1)&255')

define(`ADDwpn',
`	byte	rcsc#pADDwpn,($1)&255,($1)>>8')

define(`ADDm_',
`ADDm_COMMAn($1')

define(`ADDm_COMMAn',
`	byte	rcsc#pADDwmn,(@$1)&255,(@$1)>>8,($2)&255,($2)>>8')

define(`ADDSP',
`	byte	rcsc#pADDSP,($1)&255')

define(`AND12',
`	byte	rcsc#pAND12')

define(`ANEG1',
`	byte	rcsc#pANEG1')

define(`ARGCNTn',
`	byte	rcsc#pARGCNTn,($1)&255')

define(`ASL12',
`	byte	rcsc#pASL12')

define(`ASR12',
`	byte	rcsc#pASR12')

define(`CALL1',
`	byte	rcsc#pCALL1')

define(`CALLm',
`	byte	rcsc#pCALLm,(@$1)&255,(@$1)>>8')

define(`BYTE_', 
`ifelse(LABELON, 1, `_BYTE_, $1)', `	byte	($1)&255')')

define(`BYTEn', 
`ifelse(LABELON, 1, `_BYTEn, $1)', `	byte	($1)&255')')

define(`BYTEr0', 
`ifelse(LABELON, 1, `_BYTEr0, $1)', `	byte	0[$1]')')

define(`COM1',
`	byte	rcsc#pCOM1')

define(`COMMAn',
`,$1)')

define(`DBL1',
`	byte	rcsc#pDBL1')

define(`DBL2',
`	byte	rcsc#pDBL2')

define(`DECbp',
`	byte	rcsc#pADDbpn,(-1)&255')

define(`DECwp',
`	byte	rcsc#pADDwpn,(-1)&255,(-1)>>8')

define(`DIV12',
`	byte	rcsc#pDIV12')

define(`DIV12u',
`	byte	rcsc#pDIV12u')

define(`ENTER',
`	byte	rcsc#pENTER')

define(`EQ10f',
`	byte	rcsc#pCMP10f,(@$1)&255,(@$1)>>8,rcsc#EQf')

define(`EQ12',
`	byte	rcsc#pCMP12,rcsc#EQ')

define(`GE10f',
`	byte	rcsc#pCMP10f,(@$1)&255,(@$1)>>8,rcsc#GEf')

define(`GE12',
`	byte	rcsc#pCMP12,rcsc#GE')

define(`GE12u',
`	byte	rcsc#pCMP12,rcsc#GEu')

define(`GETb1m',
`	byte	rcsc#pGETb1m,(@$1)&255,(@$1)>>8')

define(`GETb1mu',
`	byte	rcsc#pGETb1mu,(@$1)&255,(@$1)>>8')

define(`GETb1p',
`	byte	rcsc#pGETb1p,($1)&255,($1)>>8')

define(`GETb1pu',
`	byte	rcsc#pGETb1pu,($1)&255,($1)>>8')

define(`GETb1s',
`	byte	rcsc#pGETb1s,($1)&255,($1)>>8')

define(`GETb1su',
`	byte	rcsc#pGETb1su,($1)&255,($1)>>8')

define(`GETw1m',
`	byte	rcsc#pGETw1m,(@$1)&255,(@$1)>>8')

define(`GETw1m_',
`GETw1m_PLUSn($1')

define(`GETw1m_PLUSn',
`	byte	rcsc#pGETw1m,(@$1)&255,(@$1)>>8')

define(`GETw1n',
`	byte	rcsc#pGETw1n,($1)&255,($1)>>8')

define(`GETw1p',
`	byte	rcsc#pGETw1p,($1)&255,($1)>>8')

define(`GETw1s',
`	byte	rcsc#pGETw1s,($1)&255,($1)>>8')

define(`GETw2m',
`	byte	rcsc#pGETw2m,(@$1)&255,(@$1)>>8')

define(`GETw2n',
`	byte	rcsc#pGETw2n,($1)&255,($1)>>8')

define(`GETw2p',
`	byte	rcsc#pGETw2p,($1)&255,($1)>>8')

define(`GETw2s',
`	byte	rcsc#pGETw2s,($1)&255,($1)>>8')

define(`GT10f',
`	byte	rcsc#pCMP10f,(@$1)&255,(@$1)>>8,rcsc#GTf')

define(`GT12',
`	byte	rcsc#pCMP12,rcsc#GT')

define(`GT12u',
`	byte	rcsc#pCMP12,rcsc#GTu')

define(`INCbp',
`	byte	rcsc#pADDbpn,(1)&255')

define(`INCwp',
`	byte	rcsc#pADDwpn,(1)&255,(1)>>8')

define(`WORD_', 
`ifelse(LABELON, 1, `_WORD_)', `	word	')')

define(`WORDn', 
`ifelse(LABELON, 1, `_WORDn, $1)', `	byte	($1)&255,($1)>>8')')

define(`WORDr0', 
`ifelse(LABELON, 1, `_WORDr0, $1)', `	byte	0[2*($1)]')')

define(`JMPm',
`	byte	rcsc#pJMPm,(@$1)&255,(@$1)>>8')

define(`LABm',
`$1')

define(`LE10f',
`	byte	rcsc#pCMP10f,(@$1)&255,(@$1)>>8,rcsc#LEf')

define(`LE12',
`	byte	rcsc#pCMP12,rcsc#LE')

define(`LE12u',
`	byte	rcsc#pCMP12,rcsc#LEu')

define(`LNEG1',
`	byte	rcsc#pLNEG1')

define(`LT10f',
`	byte	rcsc#pCMP10f,(@$1)&255,(@$1)>>8,rcsc#LTf')

define(`LT12',
`	byte	rcsc#pCMP12,rcsc#LT')

define(`LT12u',
`	byte	rcsc#pCMP12,rcsc#LTu')

define(`MOD12',
`	byte	rcsc#pMOD12')

define(`MOD12u',
`	byte	rcsc#pMOD12u')

define(`MOVE21',
`	byte	rcsc#pMOVE21')

define(`MUL12',
`	byte	rcsc#pMUL12')

define(`MUL12u',
`	byte	rcsc#pMUL12u')

define(`NE10f',
`	byte	rcsc#pCMP10f,(@$1)&255,(@$1)>>8,rcsc#NEf')

define(`NE12',
`	byte	rcsc#pCMP12,rcsc#NE')

define(`NEARm',
`	byte	(@$1)&255,(@$1)>>8')

define(`OR12',
`	byte	rcsc#pOR12')

define(`PLUSn',
`+$1')

define(`POINT1l',
`	byte	rcsc#pPOINT1m,(@$1)&255,(@$1)>>8')

define(`POINT1m',
`	byte	rcsc#pPOINT1m,(@$1)&255,(@$1)>>8')

define(`POINT1s',
`	byte	rcsc#pPOINT1s,($1)&255')

define(`POINT2m',
`	byte	rcsc#pPOINT2m,(@$1)&255,(@$1)>>8')

define(`POINT2m_',
`POINT2m_PLUSn($1')

define(`POINT2m_PLUSn',
`	byte	rcsc#pPOINT2m,(@$1)&255,(@$1)>>8')

define(`POINT2s',
`	byte	rcsc#pPOINT2s,($1)&255')

define(`POP2',
`	byte	rcsc#pPOP2')

define(`PUSH1',
`	byte	rcsc#pPUSH1')

define(`PUSH2',
`	byte	rcsc#pPUSH2')

define(`PUSHm',
`	byte	rcsc#pPUSHm,(@$1)&255,(@$1)>>8')

define(`PUSHp',
`	byte	rcsc#pPUSHp,($1)&255')

define(`PUSHs',
`	byte	rcsc#pPUSHs,($1)&255')

define(`PUT_m_',
`PUT_m_COMMAn($1')dnl

define(`PUT_m_COMMAn',
`	byte	rcsc#pPUTwmn,(@$1)&255,(@$1)>>8,($2)&255,($2)>>8')

define(`PUTbm1',
`	byte	rcsc#pPUTbm1,(@$1)&255,(@$1)>>8')

define(`PUTbp1',
`	byte	rcsc#pPUTbp1')

define(`PUTwm1',
`	byte	rcsc#pPUTwm1,(@$1)&255,(@$1)>>8')

define(`PUTwp1',
`	byte	rcsc#pPUTwp1')

define(`rDEC1',
`	byte	rcsc#pADD1n,(-($1))&255,(-($1))>>8')

define(`rDEC2',
`	byte	rcsc#pADD2n,(-($1))&255,(-($1))>>8')

define(`RETURN',
`	byte	rcsc#pRETURN')

define(`rINC1',
`	byte	rcsc#pADD1n,($1)&255,($1)>>8')

define(`rINC2',
`	byte	rcsc#pADD2n,($1)&255,($1)>>8')

define(`SUB_m_',
`SUB_m_COMMAn($1')

define(`SUB_m_COMMAn',
`	byte	rcsc#pADDwmn,(@$1)&255,(@$1)>>8,(-($2))&255,(-($2))>>8')

define(`SUB12',
`	byte	rcsc#pSUB12')

define(`SUB1n',
`	byte	rcsc#pADD1n,(-($1))&255,(-($1))>>8')

define(`SUBbpn',
`	byte	rcsc#pADDbpn,(-($1))&255')

define(`SUBwpn',
`	byte	rcsc#pADDwpn,(-($1))&255,(-($1))>>8')

define(`SWAP12',
`	byte	rcsc#pSWAP12')

define(`SWAP1s',
`	byte	rcsc#pSWAP1s')

define(`SWITCH',
`	byte	rcsc#pSWITCH')

define(`XOR12',
`	byte	rcsc#pXOR12')

define(`CSCINIT',
`	byte	rcsc#pCSCINIT')

define(`ENTERM',
`	byte	rcsc#pCLI')

define(`EXITM',
`	byte	rcsc#pSTI')

divert
